from VMFNode import VMFNode
import copy

class VMFFile:    
  def __init__(self):
    self.root = None
    
  def analyzeVisgroups(self):
    self.visgroups = {}
    def predicate(node):
      return node.name == "visgroups"
    visgroupsNodes = self.root.FindRecurse(predicate)
    for visgroupNode in visgroupsNodes[0].children:
      self.visgroups[int(visgroupNode.properties["visgroupid"])] = visgroupNode.properties["name"]
  
  def fromfile(self,filename):
    file = open(filename, "r")
    stack = []
    node = VMFNode(None) # root should be python list
    previousLine = None
    line = file.readline().strip()
    while line:
      if not previousLine == None:
        line = line.strip()
        if line == "{":
          stack.append(node)
          node = VMFNode(previousLine)
        elif line == "}":
          parentNode = stack.pop()
          parentNode.AddChild(node)
          node = parentNode
        elif line[0] == "\"": # TODO: better differentation of key-value pairs and node names
          split = line.split("\" \"")
          if len(split) == 2:
            node.AddProperty(split[0].strip("\""),split[1].strip("\""))
          else:
            print "WARNING: Unknown token number",len(split),"in",split
      previousLine = line
      line = file.readline()
    #print "Final depth:",len(stack)
    self.root = node
    self.analyzeVisgroups()
    return self
    
  def deepcopy(self):
    deepcopy = VMFFile()
    deepcopy.root = self.root.deepcopy()
    deepcopy.visgroups = copy.deepcopy(self.visgroups)
    return deepcopy